﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;

namespace DataGridExample.ViewModels
{
    public class MainPageViewModel : INotifyPropertyChanged
    {
        public MainPageViewModel()
        {
            _things = new ObservableCollection<Thing>();
            _codes = new List<string>();
            _codes.Add("jc-1");
            _codes.Add("jc-2");
            _codes.Add("jc-3");
            this.GenerateThings();
        }
        
        private ObservableCollection<Thing> _things;
        public ObservableCollection<Thing> ThingCollection
        {
            get { return _things; }
            set { this._things = value; }
        }

        private List<string> _codes;

        public List<string> CodesCollection
        {
            get { return _codes; }
            set { this._codes = value; }
        } 
        private void GenerateThings()
        {
            _things.Add(new Thing("one", 1, true, _codes));
            _things.Add(new Thing("two", 2, false, _codes));
            _things.Add(new Thing("thee", 3, false, _codes));
            _things.Add(new Thing("four", 4, false, _codes));
            _things.Add(new Thing("five", 5, false, _codes));
            _things.Add(new Thing("six", 6, false, _codes));
            _things.Add(new Thing("seven", 7, false, _codes));
            _things.Add(new Thing("eight", 8, false, _codes));
            _things.Add(new Thing("nine", 9, false, _codes));
            _things.Add(new Thing("ten", 10, false, _codes));
            _things.Add(new Thing("one", 11, true, _codes));
            _things.Add(new Thing("two", 12, false, _codes));
            _things.Add(new Thing("thee", 13, false, _codes));
            _things.Add(new Thing("four", 14, false, _codes));
            _things.Add(new Thing("five", 15, false, _codes));
            _things.Add(new Thing("six", 16, false, _codes));
            _things.Add(new Thing("seven", 117, false, _codes));
            _things.Add(new Thing("eight", 8, false, _codes));
            _things.Add(new Thing("nine", 19, false, _codes));
            _things.Add(new Thing("ten", 20, false, _codes));
            _things.Add(new Thing("one", 21, true, _codes));
            _things.Add(new Thing("two", 22, false, _codes));
            _things.Add(new Thing("thee", 23, false, _codes));
            _things.Add(new Thing("four", 24, false, _codes));
            _things.Add(new Thing("five", 25, false, _codes));
            _things.Add(new Thing("six", 26, false, _codes));
            _things.Add(new Thing("seven", 27, false, _codes));
            _things.Add(new Thing("eight", 28, false, _codes));
            _things.Add(new Thing("nine", 29, false, _codes));
            _things.Add(new Thing("ten", 30, false, _codes));
            _things.Add(new Thing("one", 31, true, _codes));
            _things.Add(new Thing("two", 32, false, _codes));
            _things.Add(new Thing("thee", 33, false, _codes));
            _things.Add(new Thing("four", 34, false, _codes));
            _things.Add(new Thing("five", 35, false, _codes));
            _things.Add(new Thing("six", 36, false, _codes));
            _things.Add(new Thing("seven", 37, false, _codes));
            _things.Add(new Thing("eight", 38, false, _codes));
            _things.Add(new Thing("nine", 39, false, _codes));
            _things.Add(new Thing("ten", 40, false, _codes));
            _things.Add(new Thing("one", 41, true, _codes));
            _things.Add(new Thing("two", 42, false, _codes));
            _things.Add(new Thing("thee", 43, false, _codes));
            _things.Add(new Thing("four", 44, false, _codes));
            _things.Add(new Thing("five", 45, false, _codes));
            _things.Add(new Thing("six", 46, false, _codes));
            _things.Add(new Thing("seven", 47, false, _codes));
            _things.Add(new Thing("eight", 48, false, _codes));
            _things.Add(new Thing("nine", 49, false, _codes));
            _things.Add(new Thing("ten", 50, false, _codes));
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
