﻿using DataGridExample.ViewModels;
using System;
using System.Globalization;
using Xamarin.Forms;

namespace DataGridExample.Views
{
    public class ImageConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var data = value as JobCode;
            if (data != null)
            {
                if (data.Special)
                {
                    return ImageSource.FromResource("DataGridExample.Icons.DataGrid.GreenUp.png");
                }
                else
                {
                    return ImageSource.FromResource("DataGridExample.Icons.DataGrid.RedDown.png");
                }
            }
            return ImageSource.FromResource("DataGridExample.Icons.DataGrid.Blank.png");
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
